﻿function view_onopen() {
	updateBars();
	view.setTimeout(view_onopen, 3600000);
}

/**
 * Update the 3 biorhythm bars.
**/
function updateBars() {
	if (!options.exists("year") || !options.exists("month") || !options.exists("day"))
		return;
  var birthday = new Date();
	birthday.setFullYear(options.getValue("year"), options.getValue("month"), options.getValue("day"));
	var diff = getDaysDiff(birthday, new Date());
	var physical = Math.sin(2 * Math.PI * diff / 23);
	var emotional = Math.sin(2 * Math.PI * diff / 28);
	var intellectual = Math.sin(2 * Math.PI * diff /33);
	debug.trace("Age: " + diff + " days");
	debug.trace("Physical: " + physical);
	debug.trace("Emotional: " + emotional);
	debug.trace("Intellectual: " + intellectual);
	physicalRainbow.width = Math.round(60 * (1 + physical));
	emotionalRainbow.width = Math.round(60 * (1 + emotional));
	intellectualRainbow.width = Math.round(60 * (1 + intellectual));
}

/**
 * Get number of days difference from now
 * date1 - The earlier date
 * date2 - The later date
 **/
function getDaysDiff(date1, date2) {
	var d1 = getMidnight(date1), d2 = getMidnight(date2);
	var diff = d2 - d1;
	diff /= 86400000;
	return diff;
}

/**
 * Get first second of the day
 * date - The midnight of the date to get
 * returns the midnight date
**/
function getMidnight(date) {
	date.setHours(0);
	date.setMinutes(0);
	date.setSeconds(0);
	date.setMilliseconds(0);
	return date;
}

function view_onoptionchanged() {
	debug.trace(event.propertyname);
	if (event.propertyName == "ok")
		updateBars();
}