﻿function view_onopen() {
	createYear();
	createMonth();
	createDay(true);
}
/**
 * Fill in the day combo box list
 * loadFromOption - Set true if last selection should be loaded from options.
 **/
function createDay(loadFromOptions) {
	var numOfDays = getNumOfDays(yearComboBox.selectedItem.name, monComboBox.selectedIndex);
	var lastSelection;
	if (loadFromOptions) {
		if (!options.exists("day"))
			options.putValue("day", 31);
		lastSelection = options.getValue("day") - 1;
	} else {
		lastSelection = dayComboBox.selectedIndex;
	}
	dayComboBox.removeAllElements();
	for (i = 1; i <= numOfDays; i++)
		dayComboBox.appendElement("<item name=\"" + i + "\"><label>" + i + "</label></item>");
	if (lastSelection + 1 > numOfDays)
		lastSelection = numOfDays - 1;
  dayComboBox.selectedIndex = lastSelection;
	updateDay();
}

/**
 * Update/validate the day. If it is after today, change the day to today.
 **/
function updateDay() {
	var now = new Date();
	if (yearComboBox.selectedItem.name == now.getYear() &&
			monComboBox.selectedIndex == now.getMonth() &&
			dayComboBox.selectedIndex + 1 > now.getDate())
		dayComboBox.selectedIndex = now.getDate() - 1;
}

/**
 * Fill in the year combo box list
 **/
function createYear() {
	var now = new Date();
  yearComboBox.removeAllElements();
	for (i = now.getYear(); i >= now.getYear() - 100; i--)
		yearComboBox.appendElement("<item name=\"" + i + "\"><label>" + i + "</label></item>");
	if (!options.exists("year"))
		options.putValue("year", now.getYear());
	yearComboBox.selectedIndex = now.getYear() - options.getValue("year");
}

/**
 * Fill in the month combo box list
 **/
function createMonth() {
	var monStrings = new Array (JANUARY, FEBRUARY, MARCH, APRIL, MAY, JUNE, JULY, AUGUST,
			SEPTEMBER, OCTOBER, NOVEMBER, DECEMBER);
	monComboBox.removeAllElements();
	for (i = 0; i < 12; i++)
		monComboBox.appendElement("<item name=\"" + monStrings[i] + "\"><label>" +
				monStrings[i] + "</label></item>");
	if (!options.exists("month"))
		options.putValue("month", 11);
	monComboBox.selectedIndex = options.getValue("month");
	updateMonth();
}

/**
 * Update/validate month. If it is after this month (and this year),
 * set to current month
 **/
function updateMonth() {
	var now = new Date();
	if (yearComboBox.selectedItem.name == now.getYear() &&
			monComboBox.selectedIndex > now.getMonth()) {
		monComboBox.selectedIndex = now.getMonth();
	}
	createDay(false);
}

function yearComboBox_onchange() {
	updateMonth();
}

function monComboBox_onchange() {
	updateMonth();
	createDay();
}

function dayComboBox_onchange() {
	updateDay();
}

/**
 * Returns the number of days in a given year and month
 * year - Year
 * month - Month
 **/
function getNumOfDays(year, month) {
	if (month == 0 || month == 2 || month == 4 || month == 6 || month == 7 ||
			month == 9 || month == 11) {
		return 31;
	} else if (month == 2) {
		month = (year % 4 == 0 && year % 100 != 0) ? 29 : 28;
	} else {
		return 30;
	}
}

function view_onok() {
	options.putValue("year", yearComboBox.selectedItem.name);
	options.putValue("month", monComboBox.selectedIndex);
	options.putValue("day", dayComboBox.selectedItem.name);
	options.putValue("ok", "ok");
}